/*** Interesting bit ***/
#include <Messenger.h>
#include <WString.h>
/*** end of interesting bit ***/

// these are a bunch of vars that have to do with my controller
int potPin = 0;
int fsrPin = 1; // fsr pin
int cellPin = 2; // cell pin
int potValue = 0;
int fsrValue = 0;
int cellValue = 0;
int stopRead;

int redLEDPin = 8; // red pin
int greenLEDPin = 9; // green pin
int blueLEDPin = 10; // blue pin

int redValue;
int greenValue;
int blueValue;

/*** Interesting bit ***/
Messenger message = Messenger(); 

void messageCompleted() {
  // Loop through all the available elements of the message
  while ( message.available() ) {
    redValue = message.readInt();     // taking the values off the processing string
    greenValue = message.readInt();   // you can add as many as you like as long as there is
    blueValue = message.readInt();    // space btw and carriage return in the end

    analogWrite(redLEDPin,redValue);      // change light value
    analogWrite(greenLEDPin,greenValue);
    analogWrite(blueLEDPin,blueValue);
  } 
}
/*** end of interesting bit ***/

void setup () {
  
  Serial.begin(9600);  
  
/*** Interesting bit ***/  
  message.attach(messageCompleted); // read msg
/*** end of interesting bit ***/

  pinMode (potPin, INPUT); 
  pinMode (fsrPin, INPUT);
  pinMode (cellPin, INPUT);
  pinMode (redLEDPin, OUTPUT); 
  pinMode (blueLEDPin, OUTPUT);
  pinMode (greenLEDPin, OUTPUT);
  establishContact(); 
}

void loop () {

  
/*** Interesting bit ***/    
 if (Serial.available() > 0) {       
/* reading serial from processing */

   while ( Serial.available( ) ) {    
    message.process(Serial.read( ) );    
    }    
  
  Serial.flush();
/* reading the sensor data */

  potValue = analogRead(potPin);
  fsrValue = analogRead(fsrPin);
  cellValue = analogRead(cellPin);
  
  Serial.print(potValue, DEC);
  Serial.print(",");
  
  int fsrRemap = map(fsrValue,270,550,0,255);
  fsrRemap = constrain(fsrRemap,0,255);
  Serial.print(fsrRemap, DEC);
  Serial.print(",");
  
  int cellRemap = map(cellValue,12,200,0,255); // info from sensors
  cellRemap = constrain(cellRemap,0,255);
  Serial.println(cellRemap, DEC);
  delay(150);
  //Serial.flush(); // purge the serial data
  
  } 
/*** end of interesting bit ***/
}

 void establishContact() {
  while (Serial.available() <= 0) {
       Serial.println("hello");   // send a starting message
       delay(300);
   }
 }

