import processing.video.*;    // load the video library
import processing.serial.*;   // import the Processing serial library

Serial myPort;                // serial port
boolean firstContact = false; // Whether we've heard from the microcontroller

int param1 = 0;
int param2 = 0;

void setup () {
// serial communication setup
    myPort = new Serial(this, Serial.list()[0], 9600);
// read bytes into a buffer until you get a linefeed (ASCII 10):
    myPort.bufferUntil('\n');
  
// some basic setup
  size(100 ,100);
  background(0);
}


void draw () {
  
/*** interesting bit ***/
  
  param1 = mouseX; // define vars to feed the arduino with
  param2 = mouseY;    
}


/*** Getting data off the arduino (not interesting) ***/

void serialEvent(Serial myPort) { 
  // read the serial buffer:
  String myString = myPort.readStringUntil('\n');
  // if you got any bytes other than the linefeed:
  if (myString != null) {

    myString = trim(myString);
    // if you haven't heard from the microncontroller yet, listen:
    if (firstContact == false) {
      if (myString.equals("hello")) { 
        myPort.clear();          // clear the serial port buffer
        firstContact = true;     // you've had first contact from the microcontroller
        myPort.write('A');       // ask for more
      } 
    } 
    // if you have heard from the microcontroller, proceed:
    else {
      // split the string at the commas
      // and convert the sections into integers:
      int sensors[] = int(split(myString, ','));

      // print out the values you got:
      for (int sensorNum = 0; sensorNum < sensors.length; sensorNum++) {
        print("Sensor " + sensorNum + ": " + sensors[sensorNum] + "\t"); 
      }
      // add a linefeed after all the sensor values are printed:
      println();

    }
    
/*** Interesting bit ***/

    // when you've parsed the data you have, ask for more:
    // inputing the vars into a string and carriage return
    myPort.write(param1+" "+param2+" "+param1+"\r");
    delay(10);
  }  
}




  


   

