// Imports the Serial Library
import processing.serial.*;
// Imports the Audio Libraries
import ddf.minim.*;
import ddf.minim.effects.*;
import ddf.minim.signals.*;


// Declares Variables
float bgcolor; // Background color
float fgcolor; // Fill color
float xpos, ypos; // Starting position of the ball
int pod1y, pod2y, pod3y, pod4y, pod5y, pod6y, pod7y, pod8y;
int pod1z, pod2z, pod3z, pod4z, pod5z, pod6z, pod7z, pod8z;
float podLed1 = 0;
int g = -20;
int spacing = 0;



Serial myPort; // The serial port
int[] sensors = new int[16];  // Where we'll put what we receive
int serialCount = 0;  // A count of how many bytes we receive
boolean firstContact = false;  // Whether we've heard from the microcontroller

// Initalize objects
Minim minim;
AudioPlayer pod1;
AudioPlayer pod2;
AudioPlayer pod3;
AudioPlayer pod4;
AudioPlayer pod5;
AudioPlayer pod6;
AudioPlayer pod7;
AudioPlayer pod8;

void setup() {
  // Visual Setup Stuff - Not important
  size(400, 200);
  smooth();
  textFont(createFont("Arial", 12));
  xpos = 25;
  ypos = 15;

  // I know that the first port in the serial list on my mac
  // is always my  FTDI adaptor, so I open Serial.list()[0].
  // On Windows machines, this generally opens COM1.
  // Open whatever port is the one you're using.
  String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 9600);

  // Look at me
  minim = new Minim(this);
  // loads audio files from the data folder

  pod1 = minim.loadFile("grand_central.wav", 2048);
  pod2 = minim.loadFile("lapping_water.wav", 2048);
  pod3 = minim.loadFile("ATM_buttons.wav", 2048);
  pod4 = minim.loadFile("drummer.wav", 2048);
  pod5 = minim.loadFile("firetruck.wav", 2048);
  pod6 = minim.loadFile("quiet_footsteps2.wav", 2048);
  pod7 = minim.loadFile("train_ride.wav", 2048);
  pod8 = minim.loadFile("charlieParker.wav", 2048);

  pod1.setGain(g);
  pod1.loop();
  pod2.setGain(g);
  pod2.loop();
  pod3.setGain(g);
  pod3.loop();
  pod4.setGain(g);
  pod4.loop();
  /*pod5.setGain(g);
   pod5.loop();
   pod6.setGain(g);
   pod6.loop();
   pod7.setGain(g);
   pod7.loop();
   pod8.setGain(g);
   pod8.loop();*/
}

void draw() {
  background(bgcolor);

  // When drum sound is playing say "Drums are playing":
  if (pod1.isPlaying()) {
    fill (255); 
    text("Pod 1 is playing.", xpos, ypos);
    text("Volume " + pod1.getGain(), xpos+100, ypos);
    fill(200,15,200);
    shapeMode(CENTER);
    ellipse(xpos-12, ypos - 5, 10, 10);
  }
  else {
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 1 is NOT playing.", xpos, ypos); 
  }

  if (pod2.isPlaying()) { // When piano is playing display text
    spacing = 20;
    fill (255); 
    text("Pod 2 is playing.", xpos, ypos + spacing);
    text("Volume " + pod2.getGain(), xpos+100, ypos + spacing);
    fill(20,200,200);
    shapeMode(CENTER);
    ellipse(xpos -12, spacing + 10, 10, 10);
  }
  else {
    spacing = 20;
    // Display text when piano is not playing
    fill (255); 
    text("Pod 2 is NOT playing.", xpos, ypos + spacing); 
  }
  if (pod3.isPlaying()) {
    spacing = 40;
    fill (255); 
    text("Pod 3 is playing.", xpos, ypos + spacing);
    text("Volume " + pod3.getGain(), xpos+100, ypos + spacing);
    fill(80,15,200);
    shapeMode(CENTER);
    ellipse(xpos-12, spacing + 10, 10, 10);
  }
  else {
    spacing = 40;
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 3 is NOT playing.", xpos, ypos + spacing); 
  }
  if (pod4.isPlaying()) {
    spacing = 60;
    fill (255); 
    text("Pod 4 is playing.", xpos, ypos + spacing);
    text("Volume " + pod4.getGain(), xpos+100, ypos + spacing);
    fill(200,15,80);
    shapeMode(CENTER);
    ellipse(xpos-12, spacing + 10, 10, 10);
  }
  else {
    spacing = 60;
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 4 is NOT playing.", xpos, ypos + spacing); 
  }
  if (pod5.isPlaying()) {
    spacing = 80;
    fill (255); 
    text("Pod 5 is playing.", xpos, ypos + spacing);
    text("Volume " + pod5.getGain(), xpos+100, ypos + spacing);
    fill(100,200,180);
    shapeMode(CENTER);
    ellipse(xpos-12, spacing + 10, 10, 10);
  }
  else {
    spacing = 80;
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 5 is NOT playing.", xpos, ypos + spacing); 
  }
  if (pod6.isPlaying()) {
    spacing = 100;
    fill (255); 
    text("Pod 6 is playing.", xpos, ypos + spacing);
    text("Volume " + pod6.getGain(), xpos+100, ypos + spacing);
    fill(240,80,180);
    shapeMode(CENTER);
    ellipse(xpos-12, spacing + 10, 10, 10);
  }
  else {
    spacing = 100;
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 6 is NOT playing.", xpos, ypos + spacing); 
  }
  if (pod7.isPlaying()) {
    spacing = 120;
    fill (255); 
    text("Pod 7 is playing.", xpos, ypos + spacing);
    text("Volume " + pod7.getGain(), xpos+100, ypos + spacing);
    fill(175,30,200);
    shapeMode(CENTER);
    ellipse(xpos-12, spacing + 10, 10, 10);
  }
  else {
    spacing = 120;
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 7 is NOT playing.", xpos, ypos + spacing); 
  }
  if (pod8.isPlaying()) {
    spacing = 140;
    fill (255); 
    text("Pod 8 is playing.", xpos, ypos + spacing);
    text("Volume " + pod8.getGain(), xpos+100, ypos + spacing);
    fill(120,90,80);
    shapeMode(CENTER);
    ellipse(xpos-12, spacing + 10, 10, 10);
  }
  else {
    spacing = 140;
    // Display text when drum is not playing 
    fill (255); 
    text("Pod 8 is NOT playing.", xpos, ypos + spacing); 
  }
}

void keyPressed() {

  if (key =='1') {
    pod1.setGain(g);
    pod1.loop();
  }
  if (key =='2') {
    pod2.setGain(g);
    pod2.loop();
  }
  if (key =='3') {
    pod3.setGain(g);
    pod3.loop();
  }
  if (key =='4') {
    pod4.setGain(g);
    pod4.loop();
  }
  if (key =='5') {
    pod5.setGain(g);
    pod5.loop();
  }
  if (key =='6') {
    pod6.setGain(g);
    pod6.loop();
  }
  if (key =='7') {
    pod7.setGain(g);
    pod7.loop();
  }
  if (key =='8') {
    pod8.setGain(g);
    pod8.loop();
  }

  if (key == 'p') {
    pod1.setGain(g);
    pod1.loop();
    pod2.setGain(g);
    pod2.loop();
    pod3.setGain(g);
    pod3.loop();
    pod4.setGain(g);
    pod4.loop();
    pod5.setGain(g);
    pod5.loop();
    pod6.setGain(g);
    pod6.loop();
    pod7.setGain(g);
    pod7.loop();
    pod8.setGain(g);
    pod8.loop();
  }

  if (key == ' ') {
    pod1.pause();
    pod2.pause();
    pod3.pause();
    pod4.pause();
    pod5.pause();
    pod6.pause();
    pod7.pause();
    pod8.pause();
  }
}

// This is the most important code of the whole sketch:
void serialEvent(Serial myPort) {
  // read a byte from the serial port:
  int inByte = myPort.read();
  // if this is the first byte received, and it's an A,
  // clear the serial buffer and note that you've
  // had first contact from the microcontroller.
  // Otherwise, add the incoming byte to the array:
  if (firstContact == false) {
    if (inByte == 'A') {
      myPort.clear();        // clear the serial port buffer
      firstContact = true;  // you've had first contact from the microcontroller
      myPort.write('A');    // ask for more
    }
  }

  else {
    // Add the latest byte from the serial port to array:
    sensors[serialCount] = inByte;
    serialCount++;
    // If we have 16 bytes:
    if (serialCount > 15 ) {
      pod1y = sensors[0];
      pod1z = sensors[1];
      pod2y = sensors[2];
      pod2z = sensors[3];
      pod3y = sensors[4];
      pod3z = sensors[5];
      pod4y = sensors[6];
      pod4z = sensors[7];
      pod5y = sensors[8];
      pod5z = sensors[9];
      pod6y = sensors[10];
      pod6z = sensors[11];
      pod7y = sensors[12];
      pod7z = sensors[13];
      pod8y = sensors[14];
      pod8z = sensors[15]; 


      // Map sensors[0] output range to Control the Volume (Gain) range:
      float vol = map(sensors[1], 25, 200, 6, -60);

      // Increment Volume based on current volume:
      int volIncrement = 5;
      float pod1Volup = pod1.getGain() + volIncrement;
      float pod2Volup = pod2.getGain() + volIncrement;
      float pod3Volup = pod3.getGain() + volIncrement;
      float pod4Volup = pod4.getGain() + volIncrement;
      float pod5Volup = pod5.getGain() + volIncrement;
      float pod6Volup = pod6.getGain() + volIncrement;
      float pod7Volup = pod7.getGain() + volIncrement;
      float pod8Volup = pod8.getGain() + volIncrement;

      // Master Volume Down
      float volDn = -20;

      int zThres = 35;
      int yThres = 150;

      // Control the volume for audio file
      if (pod1z < zThres) {
        pod1.setGain(volDn);
      }
      if (pod1y > yThres) {
        pod1.setGain(pod1Volup);
      }

      if (pod2z < zThres) {
        pod2.setGain(volDn);
      }
      if (pod2y > yThres) {
        pod2.setGain(pod2Volup);
      }

      if (pod3z < zThres) {
        pod3.setGain(volDn);
      }
      if (pod3y > yThres) {
        pod3.setGain(pod3Volup);
      }

      if (pod4z < zThres) {
        pod4.setGain(volDn);
      }
      if (pod4y > yThres) {
        pod4.setGain(pod4Volup);
      }

     /* if (pod5z < zThres) {
        pod5.setGain(volDn);
      }
      if (pod5y > yThres) {
        pod5.setGain(pod5Volup);
      }

      if (pod6z < zThres) {
        pod6.setGain(volDn);
      }
      if (pod6y > yThres) {
        pod6.setGain(pod6Volup);
      }

      if (pod7z < zThres) {
        pod7.setGain(volDn);
      }
      if (pod7y > yThres) {
        pod7.setGain(pod7Volup);
      }

      if (pod8z < zThres) {
        pod8.setGain(volDn);
      }
      if (pod8y > yThres) {
        pod8.setGain(pod8Volup);
      }*/

      println("pod1 =" + pod1y+ " " + pod1z);
      println("pod2 =" + pod2y+ " " + pod2z);
      println("pod3 =" + pod3y+ " " + pod3z);
      println("pod4 =" + pod4y+ " " + pod4z);
      println("pod5 =" + pod5y+ " " + pod5z);
      println("pod6 =" + pod6y+ " " + pod6z);
      println("pod7 =" + pod7y+ " " + pod7z);
      println("pod8 =" + pod8y+ " " + pod8z);


      // Send a capital A to request new sensor readings:
      myPort.write('A');
      // Reset serialCount:
      serialCount = 0;
    }
  }
}


void stop()
{
  // always close Minim audio classes when you are finished with them
  pod1.close();
  pod2.close();
  pod3.close();
  pod4.close();
  pod5.close();
  pod6.close();
  pod7.close();
  pod8.close();
  // always stop Minim before exiting.
  minim.stop();

  super.stop();
}
